<template>
  <div>
    <b-overlay :show="isSavingShipping" rounded="sm">
      <b-container fluid>
        <b-row>
          <b-col cols="6">
            <Map
              @onRegionAdded="onRegionAdded"
              @onParentRegionAdded="onParentRegionSelectionChange"
              @onParentRegionUnselected="onParentRegionSelectionChange"
            />
          </b-col>
          <b-col cols="6">
            <b-col class="d-flex align-items-stretch flex-column" v-if="selected_request">
              <b-row>
                <b-col cols="12">
                  <b-progress
                    class="mt-4"
                    height="2rem"
                    :max="selected_request.quantity"
                    show-value
                  >
                    <b-progress-bar
                      :value="inventoriesQuantityShippingsQuantitySum"
                      variant="success"
                    ></b-progress-bar>
                  </b-progress>
                </b-col>
              </b-row>
              <b-row>
                <b-col cols="12">
                  <div class="mt-5">
                    <h4>{{ selected_request.consumer_object.name }}</h4>
                    {{ selected_request.resource_object.name }}
                  </div>
                </b-col>
              </b-row>
              <b-row>
                <b-col cols="12" v-if="selected_inventories && selected_inventories.length > 0">
                  <!-- #2 -->
                  <b-row class="mt-5 border">
                    <b-col cols="3">
                      <strong>Inventario</strong>
                    </b-col>
                    <b-col cols="6">
                      <strong>Transportista</strong>
                    </b-col>
                    <b-col cols="2">
                      <strong>Cantidad</strong>
                    </b-col>
                    <b-col cols="1"></b-col>
                  </b-row>
                  <b-row v-for="(inventory, index) in selected_inventories" :key="index">
                    <b-col cols="3">{{ inventory.pk }}</b-col>
                    <b-col cols="6">{{ inventory.carrier.name }}</b-col>
                    <b-col cols="2">
                      {{ inventory.quantity }}
                      <b-icon
                        v-if="inventory.quantity > inventory.quantity_available"
                        icon="exclamation-triangle"
                        variant="danger"
                        v-b-popover.hover.top="'La cantidad a enviar ('+inventory.quantity+') es mayor que cantidad disponible ('+inventory.quantity_available+')'"
                      ></b-icon>
                    </b-col>
                    <b-col cols="1">
                      <b-button
                        @click="onDeleteSelectedInventoryButtonClick(inventory)"
                        size="sm"
                        variant="outline-danger"
                      >
                        <b-icon icon="trash" aria-hidden="true"></b-icon>
                      </b-button>
                    </b-col>
                  </b-row>
                  <!-- #/2 -->
                </b-col>
                <b-col
                  cols="12"
                  v-if="
                    selected_request &&
                      selected_request.shippings_object.length > 0
                  "
                >
                  <!-- #3 -->
                  <b-row class="mt-5 border">
                    <b-col cols="3">
                      <strong>Inventario</strong>
                    </b-col>
                    <b-col cols="3">
                      <strong>Transportista</strong>
                    </b-col>
                    <b-col cols="3">
                      <strong>Envío</strong>
                    </b-col>
                    <b-col cols="3">
                      <strong>Cantidad</strong>
                    </b-col>
                  </b-row>
                  <b-row
                    v-for="(shipping, index) in selected_request.shippings_object"
                    :key="index"
                  >
                    <b-col cols="3" v-if="shipping.inventory_object">
                      <del v-if="shipping.status == 4">{{ shipping.inventory_object.pk }}</del>
                      <span v-else>{{ shipping.inventory_object.pk }}</span>
                    </b-col>
                    <b-col cols="3" v-else>--</b-col>
                    <b-col cols="3">
                      <del v-if="shipping.status == 4">{{ shipping.carrier_object.name }}</del>
                      <span v-else>{{ shipping.carrier_object.name }}</span>
                    </b-col>
                    <b-col cols="3">
                      <div v-if="shipping.uuid">
                        <del v-if="shipping.status == 4" :id="'tooltip-target-' + shipping.uuid"></del>
                        <span
                          v-else
                          :id="'tooltip-target-' + shipping.uuid"
                        >{{ shipping.uuid.split("-")[0] }}</span>
                        <b-tooltip
                          :target="'tooltip-target-' + shipping.uuid"
                          triggers="hover"
                        >{{ shipping.uuid }}</b-tooltip>
                      </div>
                    </b-col>
                    <b-col cols="3">
                      <del v-if="shipping.status == 4">{{ shipping.quantity }}</del>
                      <span v-else>{{ shipping.quantity }}</span>
                    </b-col>
                  </b-row>
                  <!-- #/3 -->
                </b-col>
              </b-row>
              <b-row class="mt-auto align-self-end">
                <b-col cols="12 h-100">
                  <div class="h1">
                    <span
                      v-bind:class="{
                        'text-warning': !isEnoughInventories,
                        'text-danger': inventoriesQuantityShippingsQuantitySum > selected_request.quantity,
                        'text-success': isEnoughInventories
                      }"
                    >{{ inventoriesQuantityShippingsQuantitySum }}</span>
                    /
                    <span class>{{ selected_request.quantity }}</span>
                  </div>
                </b-col>
              </b-row>
              <b-row>
                <b-button variant="primary" block @click="saveShippings()">Enviar</b-button>
              </b-row>
            </b-col>
          </b-col>
        </b-row>
        <b-row>
          <b-col cols="6">
            <div>
              <h3 class="text-center">Pedidos</h3>
              <RequestList
                ref="request_list"
                @loaded-rows="onRequestListRefresh"
                @request-click="onRequestClick"
                table_selectable
                :preset_filters="{ status: 0 }"
                :lock_filters="{
                  consumer__role: request_list_lock_filters.consumer__role,
                  consumer__region__in: regionsSelected && regionsSelected.length > 0 ? regionsSelected : null,
                  shipping_needs: true,
                  consumer__region__gt1level: parentRegionsSelectedApiFilter
                }"
                :columns="[
                  'status',
                  'consumer_object',
                  'resource_object',
                  'quantity'
                ]"
              />
            </div>
          </b-col>
          <b-col cols="6">
            <h3
              v-if="selected_request"
              class="text-center"
            >Inventario de {{ selected_request.resource_object.name }}</h3>
            <InventoryList
              v-if="selected_request"
              ref="inventory_list"
              :lock_filters="{
                resource: selected_request.resource,
                distance: selectedRequestConsumerDistanceFilter,
                with_avail_quantity: true,
                owner__region__in: regionsSelected && regionsSelected.length > 0 ? regionsSelected : null,
                owner__region__gt1level: parentRegionsSelectedApiFilter
              }"
              @loaded-rows="onInventoryListRefresh"
              @inventory-click="onInventoryClick"
              table_selectable
              :columns="['owner__name', 'sum_quantity_available', 'distance']"
            />
          </b-col>
        </b-row>
      </b-container>
    </b-overlay>
    <b-modal ref="carrier_modal" centered size="xl" title="Envio" hide-footer>
      <div class="form-group">
        <label for="quantity">Cantidad</label>
        <input
          type="number"
          v-model="quantity"
          class="form-control"
          name="quantity"
          id="quantity"
          placeholder="Cantidad"
        />
      </div>
      <div v-if="!!quantity && quantity > 0">
        <PersonList @person-click="onCarrierSelect" :preset_filters="{ role: 4 }" />
      </div>
      <b-container class="mt-5">
        <b-row>
          <b-col cols="12" class="d-flex justify-content-end">
            <b-button variant="secondary" @click="onCarrierModalCancel">Cancelar</b-button>
          </b-col>
        </b-row>
      </b-container>
    </b-modal>

    <b-modal ref="save_fail_modal" centered size="md" hide-header hide-footer>
      <b-alert variant="danger" dismissible show>Algunos envíos no se han podido guardar</b-alert>
    </b-modal>
    <b-modal ref="save_success_modal" centered size="md" hide-header hide-footer>
      <b-alert variant="success" dismissible show>Envío/s programado/s correctamente</b-alert>
    </b-modal>
  </div>
</template>

<script>
import { ROLE_CONSUMER } from "@/utils/role.js";
import { mapActions } from "vuex";
import { latLng } from "leaflet";
import RequestList from "@/components/RequestList";
import InventoryList from "@/components/InventoryList";
import PersonList from "@/components/PersonList.vue";
import Map from "@/components/Map.vue";

export default {
  name: "map-panel",
  components: {
    Map,
    RequestList,
    InventoryList,
    PersonList
  },
  props: {
    request_list_lock_filters: {
      type: Object,
      default: function() {
        return {
          consumer__role: ROLE_CONSUMER
        };
      }
    }
  },
  data() {
    return {
      isSavingShipping: false,
      selected_request: undefined,
      pre_selected_inventory: undefined,
      selected_inventories: [],
      quantity: null,
      regionsSelected: null,
      parentRegionsSelected: []
    };
  },
  computed: {
    parentRegionsSelectedApiFilter() {
      if (this.parentRegionsSelected.length <= 0) {
        return "";
      }
      return this.parentRegionsSelected
        .map(element => {
          return element.pk;
        })
        .join(",");
    },
    // Cantidad sumada de los inventarios seleccionados y aún pendientes
    // de guardar
    inventoriesQuantitySum() {
      if (!this.selected_inventories || this.selected_inventories.length <= 0) {
        return 0;
      }
      let reduce = this.selected_inventories.reduce((a, b) => ({
        quantity: a.quantity + b.quantity
      }));
      return reduce.quantity;
    },
    // suma de las cantidades de los shippings ya guardados del pedido
    // seleccionado, NO SE SUMARÁN LOS PEDIDOS CANCELADOS
    selectedRequestShippingsQuantitySum() {
      if (
        !this.selected_request ||
        this.selected_request.shippings_object.length <= 0
      ) {
        return 0;
      }
      let quantity = 0;
      this.selected_request.shippings_object.forEach(shipping => {
        if (shipping.status == 4) {
          return;
        }
        quantity += shipping.quantity;
      });
      return quantity;
    },
    // cantidad de los inventories seleccionados + cantidad de los
    // shippings ya guardados de un pedido
    inventoriesQuantityShippingsQuantitySum() {
      return (
        this.inventoriesQuantitySum + this.selectedRequestShippingsQuantitySum
      );
    },
    // La cantidad seleccionada de inventarios + la cantidad de los shippings
    // ya guardados es mayor o igual a la
    // necesidad del pedido?
    isEnoughInventories() {
      if (!this.selected_request) {
        return false;
      }

      if (
        this.inventoriesQuantityShippingsQuantitySum >=
        this.selected_request.quantity
      ) {
        return true;
      }
      return false;
    },
    // Construye el filtro de distancia, coordenadas del consumer del
    // pedido seleccionado para ser pasado al listado de inventario
    selectedRequestConsumerDistanceFilter() {
      if (!this.selected_request) {
        return null;
      }
      const coordinates = this.$_.get(
        this.selected_request,
        "consumer_object.point.coordinates",
        undefined
      );
      if (!coordinates) {
        return null;
      }
      // lon;lat?
      return String(coordinates[0]) + ";" + String(coordinates[1]);
    }
  },
  methods: {
    ...mapActions({
      LOGISTICA_MIDDLE_PERSON_REQUEST_SHIPPING_CREATE:
        "shipping/LOGISTICA_MIDDLE_PERSON_REQUEST_SHIPPING_CREATE"
    }),
    onParentRegionSelectionChange(data) {
      this.parentRegionsSelected = data.items;
      if (this.$refs.inventory_list) {
        this.$refs.inventory_list.refresh();
      }
      if (this.$refs.request_list) {
        this.$refs.request_list.refresh();
      }
    },
    onRegionAdded(data) {
      let regions = data.map(item => item.pk);
      regions = JSON.stringify(regions)
        .replace("[", "")
        .replace("]", ",");

      this.regionsSelected = regions.length > 1 ? regions : null;
      if (this.$refs.inventory_list) {
        this.$refs.inventory_list.refresh();
      }
      if (this.$refs.request_list) {
        this.$refs.request_list.refresh();
      }
    },
    // Cuando el listado de pedidos se actualiza por
    // cualquier motivo
    // load all markers from request consumers
    onRequestListRefresh(data) {
      data.forEach(request => {
        if (!request.consumer) {
          return;
        }
        // TODO this.upsertMarker(request.consumer);
      });
    },
    // cuando el listado de inventario se actualiza por cualquier motivo
    onInventoryListRefresh() {},
    onInventoryClick(data) {
      // TODO: prevent duplicate
      this.pre_selected_inventory = data;
      this.quantity = data.quantity_available;
      this.$refs.carrier_modal.show();
    },
    // Resetea todas las selecciones previas realizadas por el usuario
    resetAll() {
      this.selected_request = undefined;
      this.pre_selected_inventory = undefined;
      this.selected_inventories = [];
      this.quantity = null;
    },
    // Cuando se hace click en un pedido
    onRequestClick(_data) {
      let data = Object.assign({}, _data);
      // if already selected, skip and force row selection
      if (this.selected_request && this.selected_request.pk == data.pk) {
        this.resetAll();
        return;
      }
      // format pointer with latLng
      if (this.$_.get(data, "consumer_object.point")) {
        const latlang = latLng(
          data.consumer_object.point.coordinates[1],
          data.consumer_object.point.coordinates[0]
        );
        data.consumer_object["latlang"] = latlang;
      }
      // reset selected inventories
      this.selected_inventories = [];

      // add or add + refresh
      if (this.selected_request) {
        this.selected_request = data;
        this.$refs.inventory_list.refresh();
      } else {
        this.selected_request = data;
      }
    },
    // cuando se selecciona un person del modal para seleccionar
    // transportista cuando se selecciona un inventario
    onCarrierSelect(data) {
      this.pre_selected_inventory["carrier"] = Object.assign({}, data);
      this.pre_selected_inventory.quantity = parseInt(this.quantity);

      let existent_index = this.selected_inventories.findIndex(
        el => el.pk == this.pre_selected_inventory.pk
      );
      if (existent_index > -1) {
        let existent_quantity = this.selected_inventories[existent_index]
          .quantity;
        this.pre_selected_inventory.quantity += existent_quantity;
        this.selected_inventories.splice(existent_index, 1);
      }

      this.selected_inventories.push(
        Object.assign({}, this.pre_selected_inventory)
      );

      this.pre_selected_inventory = undefined;
      this.$refs.carrier_modal.hide();
    },
    // cuando se cierra el modal de selección de transportista
    // sin seleccionar ninguno
    onCarrierModalCancel() {
      this.$refs.carrier_modal.hide();
      this.$refs.inventory_list.unselectRow(
        this.pre_selected_inventory.__row_index
      );
    },
    onDeleteSelectedInventoryButtonClick(item) {
      this.selected_inventories.splice(
        this.selected_inventories.indexOf(item),
        1
      );
    },
    // guarda los shippings configurados
    saveShippings() {
      if (
        this.inventoriesQuantityShippingsQuantitySum >
        this.selected_request.quantity
      ) {
        return false;
      }
      this.isSavingShipping = true;
      let promises = [];
      let inventories_save_fail = [];
      this.selected_inventories.forEach(inventory => {
        let __shipping_save_promise = this.LOGISTICA_MIDDLE_PERSON_REQUEST_SHIPPING_CREATE(
          {
            person_pk: localStorage.getItem("pk_person"),
            request_pk: this.selected_request.pk,
            data: {
              carrier: inventory.carrier.pk,
              quantity: inventory.quantity,
              inventory: inventory.pk
            }
          }
        ).then(
          () => {},
          () => {
            inventories_save_fail.push(inventory);
          }
        );
        promises.push(__shipping_save_promise);
        Promise.all(promises).then(
          () => {
            this.isSavingShipping = false;
            this.selected_inventories = inventories_save_fail;
            this.selected_request = undefined;
            this.$refs.request_list.refresh();
            this.$refs.save_success_modal.show();
          },
          () => {
            this.isSavingShipping = false;
            this.selected_inventories = inventories_save_fail;
            this.showShippingSaveFailAlert = true;
            this.$refs.save_fail_modal.show();
          }
        );
      });
    }
  }
};
</script>
